%define _pkglibdir	%{_libdir}/%{name}
%define reqprog		%{_builddir}/find-requires-%{name}
%define prvprog		%{_builddir}/find-provides-%{name}
%define _use_internal_dependency_generator	0

Summary:	A memory debugger
Name:		valgrind
Version:	1.9.6
Release:	1
URL:		http://developer.kde.org/~sewardj/
Source0:	http://developer.kde.org/~sewardj/%{name}-%{version}.tar.bz2
Source1:	valgrind-nptltest.c
Patch0:		valgrind-1.9.5-nptl.patch
License:	GPL
Group:		Development/Debuggers
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires:	XFree86-devel

%package devel
Summary:	Header-files for valgrind
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description
Valgrind is a GPL'd tool to help you find memory-management problems in
your programs. When a program is run under Valgrind's supervision, all
reads and writes of memory are checked, and calls to malloc/new/free/delete
are intercepted. As a result, Valgrind can detect problems such as:

    * Use of uninitialised memory
    * Reading/writing memory after it has been free'd
    * Reading/writing off the end of malloc'd blocks
    * Reading/writing inappropriate areas on the stack
    * Memory leaks -- where pointers to malloc'd blocks are lost forever
    * Passing of uninitialised and/or unaddressible memory to system calls
    * Mismatched use of malloc/new/new [] vs free/delete/delete []
    * Some misuses of the POSIX pthreads API 


%description devel
Valgrind is a GPL'd tool to help you find memory-management problems
in your programs.

This package contains header-files which are needed to develop
applications based on valgrind.


%prep 
%setup -q -n %{name}-%{version}
%patch0 -p1 -b .nptl

cat << 'EOF' >%{prvprog}
#! /bin/sh
%{__find_provides} | grep -v '^libpthread.so'
exit 0
EOF
chmod +x '%{prvprog}'

cat <<'EOF' >%{reqprog}
#! /bin/sh
%{__find_requires} | grep -v 'libc.so.6(GLIBC_PRIVATE)'
exit 0
EOF
chmod +x '%{reqprog}'

%define __find_requires		%{reqprog}
%define __find_provides		%{prvprog}


%build
## Provide the NPTL test of configure as a separate binary; if not
## compilable, use a simple sh-script returning 'no'
%{__cc} %{optflags} %{SOURCE1} -lpthread -o valgrind-nptltest || {
	echo -e '#!/bin/sh\necho no' >valgrind-nptltest
}

%configure

# Workaround for broken make (RH bugzilla #88846)
unset CFLAGS
%{__make} %{?_smp_mflags} AM_CPPFLAGS="$RPM_OPT_FLAGS"


%install
rm -rf $RPM_BUILD_ROOT html
%{__make} install DESTDIR=${RPM_BUILD_ROOT} docdir=/html
mv -f ${RPM_BUILD_ROOT}/html .

%{__install} -p -m755 valgrind-nptltest ${RPM_BUILD_ROOT}%{_pkglibdir}/nptltest


%clean
rm -rf $RPM_BUILD_ROOT %{reqprog} %{prvprog}


%files
%defattr(-,root,root)
%doc ACKNOWLEDGEMENTS AUTHORS COPYING ChangeLog NEWS 
%doc PATCHES_APPLIED README* TODO
%doc html
%{_bindir}/*
%{_pkglibdir}

%files devel
%defattr(-,root,root)
%{_includedir}/*


%changelog
* Tue May 13 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 0:1.9.6-0.fdr.1
- updated to 1.9.6
- honor optflags
- added %%{?_smp_mflags}

* Sat Apr 19 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 0:1.9.5-0.fdr.3
- removed INSTALL from filelist
- NPTL tests will be done at runtime now
- made XFree86-devel a build-requirement
- fixed find-requires/provides scripts not to fail when requirements
  or provides can not be found; this prevents warnings while creating
  the devel subpackage
* Fri Apr 18 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 0:1.9.5-0.fdr.2
- fixed generated dependencies/provides; with rpm 4.2 the
  _use_internal_dependency_generator macro must be unset also
- changed BuildRoot
* Fri Apr 18 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 0:1.9.5-0.fdr.1
- prepared for fedora.us
* Fri Apr 11 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 1:1.9.5-1
- updated to 1.9.5
* Thu Oct 17 2002 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 1:1.0.4-1
- Updated to 1.0.4
* Thu Sep 26 2002 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 1:1.0.3-1
- Updated to 1.0.3
* Thu Aug  1 2002 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 1:1.0-1
- Updated to 1.0
* Mon Jun  3 2002 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 0.20020601-1
- Updated to 20020601 snapshot
* Tue Apr 30 2002 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 0.20020430-1
- Updated to 20020430 snapshot
* Mon Apr 22 2002 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 0.20020422-1
- Updated to 20020422 snapshop
- Reworked .glibc23 patch
* Mon Mar 23 2002 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 0.20020324-1
- Updated to 20020324 snapshot
- Changed %%build and %%install since valgrind is using automake/autoconf now
* Fri Mar  1 2002 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de>
- Initial build.

